Loading...
Searching...
No Matches
XMLConversion Class Reference

`#include <openbabel/xml.h>`

Inheritance diagram for XMLConversion:
[legend]

## Public Types

typedef std::map< std::string, XMLBaseFormat * > | NsMapType

## Public Member Functions

| XMLConversion (OBConversion *pConv)
| ~XMLConversion ()
bool | SetupReader ()
bool | SetupWriter ()
bool | ReadXML (XMLBaseFormat *pFormat, OBBase *pOb)
int | SkipXML (const char *ctag)
bool | IsLast ()
int | GetOutputIndex ()
xmlTextReaderPtr | GetReader () const
xmlTextWriterPtr | GetWriter () const
void | OutputToStream ()
void | LookForNamespace ()
std::string | GetAttribute (const char *attrname)
std::string | GetContent ()
bool | GetContentInt (int &value)
bool | GetContentDouble (double &value)
Parameter get and set
These return a filtered stream for reading/writing (possible filters include compression, decompression, and newline transformation)
std::istream * | GetInStream () const
std::ostream * | GetOutStream () const
void | SetInStream (std::istream *pIn, bool takeOwnership=false)
void | SetOutStream (std::ostream *pOut, bool takeOwnership=false)
bool | SetInAndOutFormats (const char *inID, const char *outID, bool ingzip=false, bool outgzip=false)
bool | SetInAndOutFormats (OBFormat *pIn, OBFormat *pOut, bool ingzip=false, bool outgzip=false)
bool | SetInFormat (const char *inID, bool isgzip=false)
bool | SetInFormat (OBFormat *pIn, bool isgzip=false)
bool | SetOutFormat (const char *outID, bool isgzip=false)
bool | SetOutFormat (OBFormat *pOut, bool isgzip=false)
OBFormat * | GetInFormat () const
OBFormat * | GetOutFormat () const
bool | GetInGzipped () const
bool | GetOutGzipped () const
std::string | GetInFilename () const
std::string | GetOutFilename () const
std::streampos | GetInPos () const
size_t | GetInLen () const
const char * | GetTitle () const
OBConversion * | GetAuxConv () const
void | SetAuxConv (OBConversion *pConv)
Supported file format
std::vector< std::string > | GetSupportedInputFormat ()
std::vector< std::string > | GetSupportedOutputFormat ()
Conversion
int | Convert (std::istream *is, std::ostream *os)
int | Convert ()
int | FullConvert (std::vector< std::string > &FileList, std::string &OutputFileName, std::vector< std::string > &OutputFileList)
Conversion loop control
int | AddChemObject (OBBase *pOb)
OBBase * | GetChemObject ()
bool | IsFirstInput ()
void | SetFirstInput (bool b=true)
int | GetOutputIndex () const
void | SetOutputIndex (int indx)
void | SetMoreFilesToCome ()
void | SetOneObjectOnly (bool b=true)
void | SetLast (bool b)
bool | IsLastFile ()
int | GetCount () const

## Static Public Member Functions

static NsMapType & | Namespaces ()
static void | RegisterXMLFormat (XMLBaseFormat *pFormat, bool IsDefault=false, const char *uri=nullptr)
static XMLConversion * | GetDerived (OBConversion *pConv, bool ForReading=true)
static XMLBaseFormat * | GetDefaultXMLClass ()
static int | ReadStream (void *context, char *buffer, int len)
static int | WriteStream (void *context, const char *buffer, int len)
Collection of formats
static int | RegisterFormat (const char *ID, OBFormat *pFormat, const char *MIME=nullptr)
static OBFormat * | FindFormat (const char *ID)
static OBFormat * | FindFormat (const std::string ID)
static OBFormat * | FormatFromExt (const char *filename)
static OBFormat * | FormatFromExt (const char *filename, bool &isgzip)
static OBFormat * | FormatFromExt (const std::string filename)
static OBFormat * | FormatFromExt (const std::string filename, bool &isgzip)
static OBFormat * | FormatFromMIME (const char *MIME)
static bool | GetNextFormat (Formatpos &itr, const char *&str, OBFormat *&pFormat)
Information
static const char * | Description ()

## Public Attributes

bool | _SkipNextRead

## Option handling

Three types of Option provide information and control instructions to the conversion process, INOPTIONS, OUTOPTIONS, GENOPTIONS, and are stored in each OBConversion object in separate maps. Each option has an id and an optional text string. They are set individually by AddOption() or (rarely) collectively in SetOptions(). Options cannot be altered but can be replaced with AddOption() and deleted with RemoveOption(), which, however, should be used in an op derived from OBOp (because of iterator invalidation).

If the "Convert" interface is used, the GENOPTIONS are acted upon in the OBBase::DoTransformations() functions (currently only OBMol has one). This happens after the object has been input but before it has been output. All the options are available to input and output formats, etc. via the IsOption() function, and the interpretation of any text string needs to be done subsequently.

In the commandline interface, options with single character ids are are indicated like -s, and those with multiple character ids like –gen3D. An option may have one or more parameters which appear, space separated, in the option's text string. With babel, unless the option is at the end of the command, it is necessary for the number of its parameters to be exactly that specified in RegisterOptionParam(). The default is 0, but if it is more, and babel is likely to be used, this function should be called in the constructor of a format or op. With obabel (or the GUI), it is not necessary to call RegisterOptionParam().

New GENOPTIONS can be defined (as plugins) using the class OBOp.

It is customary for a format or op to document any INOPTIONS or OUTPTIONS it uses in its Description() function. As well as providing documentation during use, this is also parsed by the GUI to construct its checkboxes,etc., so it is advisable to give new Descriptions the same form as existing ones.

Some conversion options, such as -f, -l, -m, are unlikely to be used in programming, but are listed in OBConversion::Description(). The built-in GENOPTIONS for OBMol objects are listed in OBMol::ClassDescription() which is in transform.cpp and also in this documentation under AddOption().

enum | Option_type { INOPTIONS , OUTOPTIONS , GENOPTIONS , ALL }
const char * | IsOption (const char *opt, Option_type opttyp=OUTOPTIONS)
const std::map< std::string, std::string > * | GetOptions (Option_type opttyp)
void | AddOption (const char *opt, Option_type opttyp=OUTOPTIONS, const char *txt=nullptr)
bool | RemoveOption (const char *opt, Option_type optype)
void | SetOptions (const char *options, Option_type opttyp)
void | CopyOptions (OBConversion *pSourceConv, Option_type typ=ALL)
static void | RegisterOptionParam (std::string name, OBFormat *pFormat, int numberParams=0, Option_type typ=OUTOPTIONS)
static int | GetOptionParams (std::string name, Option_type typ)

## Convenience functions

bool | Write (OBBase *pOb, std::ostream *pout=nullptr)
std::string | WriteString (OBBase *pOb, bool trimWhitespace=false)
bool | WriteFile (OBBase *pOb, std::string filePath)
void | CloseOutFile ()
bool | Read (OBBase *pOb, std::istream *pin=nullptr)
bool | ReadString (OBBase *pOb, std::string input)
bool | ReadFile (OBBase *pOb, std::string filePath)
bool | OpenInAndOutFiles (std::string infilepath, std::string outfilepath)
void | ReportNumberConverted (int count, OBFormat *pFormat=nullptr)
int | NumInputObjects ()
static OBFormat * | GetDefaultFormat ()
typedef std::map< std::string, int > | OPAMapType
typedef FilteringInputStream< LineEndingExtractor > | LEInStream
std::string | InFilename
std::string | OutFilename
std::istream * | pInput
std::vector< std::istream * > | ownedInStreams
std::ostream * | pOutput
std::vector< std::ostream * > | ownedOutStreams
OBFormat * | pInFormat
OBFormat * | pOutFormat
std::map< std::string, std::string > | OptionsArray [3]
int | Index
unsigned int | StartNumber
unsigned int | EndNumber
int | Count
bool | m_IsFirstInput
bool | m_IsLast
bool | MoreFilesToCome
bool | OneObjectOnly
bool | ReadyToInput
bool | SkippedMolecules
bool | inFormatGzip
bool | outFormatGzip
OBBase * | pOb1
std::streampos | wInpos
std::streampos | rInpos
size_t | wInlen
size_t | rInlen
OBConversion * | pAuxConv
std::vector< std::string > | SupportedInputFormat
std::vector< std::string > | SupportedOutputFormat
static OBFormat * | pDefaultFormat
static std::string | BatchFileName (std::string &BaseName, std::string &InFile)
static std::string | IncrementedFileName (std::string &BaseName, const int Count)
static bool | CheckForUnintendedBatch (const std::string &infile, const std::string &outfile)
static OPAMapType & | OptionParamArray (Option_type typ)
void | ClearInStreams ()
bool | SetStartAndEnd ()
bool | OpenAndSetFormat (bool SetFormat, std::ifstream *is, std::stringstream *ss=nullptr)

## Detailed Description

A subclass for conversion of XML formats.

An extended OBConversion class which includes a libxml2 reader for use with XML formats. Copies an OBConversion and then extends it with a XML parser. Instances made on the heap are deleted when the original OBConversion object is.

This class is not intended to be used externally – instead use OBConversion which will find both XML and non-XML OBFormats.

Instead, this subclass also has support for handling specific needs in XML formats. For example, an XML file may include multiple namespaces, and the conversion should call appropriate XMLBaseFormat formats as needed.

## Member Typedef Documentation

## NsMapType

typedef std::map<std::string, XMLBaseFormat*> NsMapType

## OPAMapType

typedef std::map<std::string,int> OPAMapType

protected inherited

## LEInStream

typedef FilteringInputStream< LineEndingExtractor > LEInStream

protected inherited

## Member Enumeration Documentation

## Option_type

enum Option_type

inherited

Three types of options set on the the command line by -a? , -x? , or -?

Enumerator
INOPTIONS |
OUTOPTIONS |
GENOPTIONS |
ALL |

## Constructor & Destructor Documentation

## XMLConversion()

XMLConversion | ( | OBConversion * | pConv | ) |

Existing OBConversion instance copied.

Referenced by GetDerived().

## ~XMLConversion()

~XMLConversion | ( |  | ) |

Frees reader and writer if necessary.

## Member Function Documentation

## SetupReader()

bool SetupReader | ( |  | ) |

opens libxml2 reader

## SetupWriter()

bool SetupWriter | ( |  | ) |

opens libxml2 writer

## ReadXML()

bool ReadXML | ( | XMLBaseFormat * | pFormat,
|  | OBBase * | pOb )

Parses the input xml stream and sends each element to the format's callback routines.

## SkipXML()

int SkipXML | ( | const char * | ctag | ) |

Read and discard XML text up to the next occurrence of the tag e.g."/molecule>" This is left as the current node. Returns 1 on success, 0 if not found, -1 if failed.

## Namespaces()

NsMapType & Namespaces | ( |  | ) |

inline static

This static function returns a reference to the map Avoids "static initialization order fiasco"

## RegisterXMLFormat()

void RegisterXMLFormat | ( | XMLBaseFormat * | pFormat,
|  | bool | IsDefault = false,
|  | const char * | uri = nullptr )

static

## GetDerived()

XMLConversion * GetDerived | ( | OBConversion * | pConv,
|  | bool | ForReading = true )

static

Returns the extended OBConversion class, making it if necessary.

Referenced by XMLMoleculeFormat::ReadMolecule(), and XMLBaseFormat::SkipObjects().

## IsLast()

bool IsLast | ( |  | ) |

inline

Because OBConversion::Convert is still using the unextended OBConversion object we need to obtain the conversion parameters from it when requested

## GetOutputIndex() [1/2]

int GetOutputIndex | ( |  | ) |

inline

## GetReader()

xmlTextReaderPtr GetReader | ( |  | ) | const

inline

## GetWriter()

xmlTextWriterPtr GetWriter | ( |  | ) | const

inline

## OutputToStream()

void OutputToStream | ( |  | ) |

inline

## GetDefaultXMLClass()

XMLBaseFormat * GetDefaultXMLClass | ( |  | ) |

inline static

## LookForNamespace()

void LookForNamespace | ( |  | ) |

inline

## ReadStream()

int ReadStream | ( | void * | context,
|  | char * | buffer,
|  | int | len )

static

Static callback functions for xmlReaderForIO().

## WriteStream()

int WriteStream | ( | void * | context,
|  | const char * | buffer,
|  | int | len )

static

## GetAttribute()

std::string GetAttribute | ( | const char * | attrname | ) |

## GetContent()

std::string GetContent | ( |  | ) |

Sets value to element content. Returns false if there is no content.

## GetContentInt()

bool GetContentInt | ( | int & | value | ) |

Sets value to element content as an integer. Returns false if there is no content.

## GetContentDouble()

bool GetContentDouble | ( | double & | value | ) |

Sets value to element content as an double. Returns false if there is no content.

## RegisterFormat()

int RegisterFormat | ( | const char * | ID,
|  | OBFormat * | pFormat,
|  | const char * | MIME = nullptr )

static inherited

Called once by each format class.

Class information on formats is collected by making an instance of the class derived from OBFormat(only one is usually required). RegisterFormat() is called from its constructor.

If the compiled format is stored separately, like in a DLL or shared library, the initialization code makes an instance of the imported OBFormat class.

## FindFormat() [1/2]

OBFormat * FindFormat | ( | const char * | ID | ) |

static inherited

Searches registered formats.

Referenced by FormatFromExt(), SetInFormat(), and SetOutFormat().

## FindFormat() [2/2]

OBFormat * FindFormat | ( | const std::string | ID | ) |

static inherited

Searches registered formats.

Since
  version 2.3

## FormatFromExt() [1/4]

OBFormat * FormatFromExt | ( | const char * | filename | ) |

static inherited

Searches registered formats for an ID the same as the file extension.

Examples
  obconformersearch_default.cpp, and obforcefield_energy.cpp.

Referenced by FormatFromExt(), FormatFromExt(), FormatFromExt(), OpenAndSetFormat(), OpenInAndOutFiles(), ReadFile(), and WriteFile().

## FormatFromExt() [2/4]

OBFormat * FormatFromExt | ( | const char * | filename,
|  | bool & | isgzip )

static inherited

## FormatFromExt() [3/4]

OBFormat * FormatFromExt | ( | const std::string | filename | ) |

static inherited

Searches registered formats for an ID the same as the file extension.

Since
  version 2.3

## FormatFromExt() [4/4]

OBFormat * FormatFromExt | ( | const std::string | filename,
|  | bool & | isgzip )

static inherited

## FormatFromMIME()

OBFormat * FormatFromMIME | ( | const char * | MIME | ) |

static inherited

Searches registered formats for a MIME the same as the chemical MIME type passed.

## GetNextFormat()

bool GetNextFormat | ( | Formatpos & | itr,
|  | const char *& | str,
|  | OBFormat *& | pFormat )

static inherited

Deprecated!.Repeatedly called to recover available Formats.

## Description()

const char * Description | ( |  | ) |

static inherited

## GetInStream()

std::istream * GetInStream | ( |  | ) | const

inline inherited

Referenced by OBMoleculeFormat::DeferMolOutput(), NumInputObjects(), and OBMoleculeFormat::ReadChemObjectImpl().

## GetOutStream()

std::ostream * GetOutStream | ( |  | ) | const

inline inherited

## SetInStream()

void SetInStream | ( | std::istream * | pIn,
|  | bool | takeOwnership = false )

inherited

Set input stream. If takeOwnership is true, will deallocate when done. If isGzipped is true, will treat as a gzipped stream regardless of option settings,.

Set input stream, removing/deallocating previous stream if necessary. If takeOwnership is true, takes responsibility for freeing pIn

Referenced by Convert(), FullConvert(), OBConversion(), OpenInAndOutFiles(), operator=(), OBConversion::StreamState::popInput(), Read(), ReadFile(), ReadString(), and ~OBConversion().

## SetOutStream()

void SetOutStream | ( | std::ostream * | pOut,
|  | bool | takeOwnership = false )

inherited

Set output stream, removing/deallocating previous stream if necessary. If takeOwnership is true, takes responsibility for freeing pOut Be aware that if the output stream is gzipped format, then this outstream either needs to be replaced (e.g., SetOutStream(NULL)) or the OBConversion destroyed before the underlying outputstream is deallocated.

Referenced by CloseOutFile(), Convert(), FullConvert(), OBConversion(), OpenInAndOutFiles(), operator=(), OBConversion::StreamState::popOutput(), Write(), WriteFile(), WriteString(), and ~OBConversion().

## SetInAndOutFormats() [1/2]

bool SetInAndOutFormats | ( | const char * | inID,
|  | const char * | outID,
|  | bool | inzip = false,
|  | bool | outzip = false )

inherited

Sets the formats from their ids, e g CML.

Sets the formats from their ids, e g CML. If inID is NULL, the input format is left unchanged. Similarly for outID Returns true if both formats have been successfully set at sometime

## SetInAndOutFormats() [2/2]

bool SetInAndOutFormats | ( | OBFormat * | pIn,
|  | OBFormat * | pOut,
|  | bool | ingzip = false,
|  | bool | outgzip = false )

inherited

## SetInFormat() [1/2]

bool SetInFormat | ( | const char * | inID,
|  | bool | isgzip = false )

inherited

Sets the input format from an id e.g. CML.

Examples
  obconformersearch_default.cpp, obconversion_readstring.cpp, and obforcefield_energy.cpp.

Referenced by OpenBabel::CompileSmilesQuery(), OpenAndSetFormat(), OBMoleculeFormat::ReadNameIndex(), SetInAndOutFormats(), and SetInAndOutFormats().

## SetInFormat() [2/2]

bool SetInFormat | ( | OBFormat * | pIn,
|  | bool | isgzip = false )

inherited

## SetOutFormat() [1/2]

bool SetOutFormat | ( | const char * | outID,
|  | bool | isgzip = false )

inherited

Sets the output format from an id e.g. CML.

Examples
  obconformersearch_default.cpp.

Referenced by OBBuilder::Build(), UniqueTautomerFunctor::operator()(), SetInAndOutFormats(), and SetInAndOutFormats().

## SetOutFormat() [2/2]

bool SetOutFormat | ( | OBFormat * | pOut,
|  | bool | isgzip = false )

inherited

## GetInFormat()

OBFormat * GetInFormat | ( |  | ) | const

inline inherited

Referenced by NumInputObjects().

## GetOutFormat()

OBFormat * GetOutFormat | ( |  | ) | const

inline inherited

Referenced by OBMoleculeFormat::DoOutputOptions(), and OBMoleculeFormat::OutputDeferredMols().

## GetInGzipped()

bool GetInGzipped | ( |  | ) | const

inline inherited

## GetOutGzipped()

bool GetOutGzipped | ( |  | ) | const

inline inherited

## GetInFilename()

std::string GetInFilename | ( |  | ) | const

inline inherited

## GetOutFilename()

std::string GetOutFilename | ( |  | ) | const

inline inherited

## GetInPos()

std::streampos GetInPos | ( |  | ) | const

inline inherited

Get the position in the input stream of the object being read.

## GetInLen()

size_t GetInLen | ( |  | ) | const

inline inherited

Get the length in the input stream of the object being read.

## GetTitle()

const char * GetTitle | ( |  | ) | const

inherited

Returns
  a default title which is the filename

## GetAuxConv()

OBConversion * GetAuxConv | ( |  | ) | const

inline inherited

Extension method: deleted in ~OBConversion().

## SetAuxConv()

void SetAuxConv | ( | OBConversion * | pConv | ) |

inline inherited

## IsOption()

const char * IsOption | ( | const char * | opt,
|  | Option_type | opttyp = OUTOPTIONS )

inherited

Determine whether an option is set.

Returns
  NULL if option not and a pointer to the associated text if it is

Referenced by Convert(), OBMoleculeFormat::DoOutputOptions(), FullConvert(), NumInputObjects(), OBMoleculeFormat::ReadChemObjectImpl(), SetInStream(), SetOutStream(), SetStartAndEnd(), and OBMoleculeFormat::WriteChemObjectImpl().

## GetOptions()

const std::map< std::string, std::string > * GetOptions | ( | Option_type | opttyp | ) |

inline inherited

Access the map with option name as key and any associated text as value.

Referenced by OBMoleculeFormat::OutputDeferredMols(), and OBMoleculeFormat::ReadChemObjectImpl().

## AddOption()

void AddOption | ( | const char * | opt,
|  | Option_type | opttyp = OUTOPTIONS,
|  | const char * | txt = nullptr )

inherited

Set an option of specified type, with optional text.

Referenced by OBMoleculeFormat::DeferMolOutput().

## RemoveOption()

bool RemoveOption | ( | const char * | opt,
|  | Option_type | optype )

inherited

## SetOptions()

void SetOptions | ( | const char * | options,
|  | Option_type | opttyp )

inherited

Set several single character options of specified type from string like ab"btext"c"ctext".

## RegisterOptionParam()

void RegisterOptionParam | ( | std::string | name,
|  | OBFormat * | pFormat,
|  | int | numberParams = 0,
|  | Option_type | typ = OUTOPTIONS )

static inherited

For example -h takes 0 parameters; -f takes 1. Call in a format constructor.

Referenced by OBConversion(), OBConversion(), and OBMoleculeFormat::OBMoleculeFormat().

## GetOptionParams()

int GetOptionParams | ( | std::string | name,
|  | Option_type | typ )

static inherited

Returns
  the number of parameters registered for the option, or 0 if not found

## CopyOptions()

void CopyOptions | ( | OBConversion * | pSourceConv,
|  | Option_type | typ = ALL )

inherited

Copies the options (by default of all types) from one OBConversion Object to another.

## GetSupportedInputFormat()

std::vector< std::string > GetSupportedInputFormat | ( |  | ) |

inherited

Returns the list of supported input format

## GetSupportedOutputFormat()

std::vector< std::string > GetSupportedOutputFormat | ( |  | ) |

inherited

Returns the list of supported output format

## Convert() [1/2]

int Convert | ( | std::istream * | is,
|  | std::ostream * | os )

inherited

Conversion for single input and output stream.

Convert molecules from is into os. If either is null, uses existing streams. If streams are specified, they do not replace any existing streams.

## Convert() [2/2]

int Convert | ( |  | ) |

inherited

Conversion with existing streams.

Actions the "convert" interface. Calls the OBFormat class's ReadMolecule() which

- makes a new chemical object of its chosen type (e.g. OBMol)
- reads an object from the input file
- subjects the chemical object to 'transformations' as specified by the Options
- calls AddChemObject to add it to a buffer. The previous object is first output via the output Format's WriteMolecule(). During the output process calling IsFirst() and GetIndex() (the number of objects including the current one already output. allows more control, for instance writing <cml> and </cml> tags for multiple molecule outputs only.

AddChemObject does not save the object passed to it if it is NULL (as a result of a DoTransformation()) or if the number of the object is outside the range defined by StartNumber and EndNumber.This means the start and end counts apply to all chemical objects found whether or not they are output.

If ReadMolecule returns false the input conversion loop is exited.

Referenced by Convert(), and FullConvert().

## FullConvert()

int FullConvert | ( | std::vector< std::string > & | FileList,
|  | std::string & | OutputFileName,
|  | std::vector< std::string > & | OutputFileList )

inherited

Conversion with multiple input/output files: makes input and output streams, and carries out normal, batch, aggregation, and splitting conversion.

Makes input and output streams, and carries out normal, batch, aggregation, and splitting conversion.

Normal Done if FileList contains a single file name and OutputFileName does not contain a *.

Aggregation Done if FileList has more than one file name and OutputFileName does not contain * . All the chemical objects are converted and sent to the single output file.

Splitting Done if FileList contains a single file name and OutputFileName contains a * . Each chemical object in the input file is converted and sent to a separate file whose name is OutputFileName with the replaced by 1, 2, 3, etc. OutputFileName must have at least one character other than the * before the extension. For example, if OutputFileName is NEW*.smi then the output files are NEW1.smi, NEW2.smi, etc.

Batch Conversion Done if FileList has more than one file name and contains a * . Each input file is converted to an output file whose name is OutputFileName with the * replaced by the inputfile name without its path and extension. So if the input files were inpath/First.cml, inpath/Second.cml and OutputFileName was NEW*.mol, the output files would be NEWFirst.mol, NEWSecond.mol.

If FileList is empty, the input stream that has already been set (usually in the constructor) is used. If OutputFileName is empty, the output stream already set is used.

On exit, OutputFileList contains the names of the output files.

Returns the number of Chemical objects converted.

## AddChemObject()

int AddChemObject | ( | OBBase * | pOb | ) |

inherited

Adds to internal array during input.

Called by ReadMolecule() to deliver an object it has read from an input stream. Used in two modes:

- When Count is negative it is left negative and the routine is just a store for an OBBase object. The negative value returned tells the calling routine that no more objects are required.
- When count is >=0, probably set by Convert(), it acts as a queue of 2: writing the currently stored value before accepting the supplied one. This delay allows output routines to respond differently when the written object is the last. Count is incremented with each call, even if pOb=NULL. Objects are not added to the queue if the count is outside the range StartNumber to EndNumber. There is no upper limit if EndNumber is zero. The return value is Count ((>0) or 0 if WriteChemObject returned false.

Referenced by OBMoleculeFormat::ReadChemObjectImpl().

## GetChemObject()

OBBase * GetChemObject | ( |  | ) |

inherited

Retrieve from internal array during output.

Retrieves an object stored by AddChemObject() during output.

Referenced by OBMoleculeFormat::WriteChemObjectImpl().

## IsFirstInput()

bool IsFirstInput | ( |  | ) |

inherited

True if the first input object is being processed.

Referenced by OBMoleculeFormat::DeferMolOutput(), and OBMoleculeFormat::ReadChemObjectImpl().

## SetFirstInput()

void SetFirstInput | ( | bool | b = true | ) |

inherited

Setwhether or not is the first input.

Referenced by Convert(), and FullConvert().

## GetOutputIndex() [2/2]

int GetOutputIndex | ( |  | ) | const

inherited

Retrieves number of ChemObjects that have been actually output.

Returns the number of objects which have been output or are currently being output. The outputindex is incremented when an object for output is fetched by GetChemObject(). So the function will return 1 if called from WriteMolecule() during output of the first object.

Referenced by OBMoleculeFormat::DoOutputOptions().

## SetOutputIndex()

void SetOutputIndex | ( | int | indx | ) |

inherited

Sets output index (maybe to control whether seen as first object).

Referenced by FullConvert(), OBMoleculeFormat::OutputDeferredMols(), and OBMoleculeFormat::WriteChemObjectImpl().

## SetMoreFilesToCome()

void SetMoreFilesToCome | ( |  | ) |

inherited

Used with multiple input files. Off by default.

Referenced by FullConvert().

## SetOneObjectOnly()

void SetOneObjectOnly | ( | bool | b = true | ) |

inherited

Used with multiple input files. Off by default.

Referenced by FullConvert(), OBMoleculeFormat::OutputDeferredMols(), SetLast(), and WriteString().

## SetLast()

void SetLast | ( | bool | b | ) |

inline inherited

Synonym for SetOneObjectOnly().

## IsLastFile()

bool IsLastFile | ( |  | ) |

inline inherited

True if no more files to be read.

## GetCount()

int GetCount | ( |  | ) | const

inline inherited

Number of objects read and processed Incremented after options are processed, so 0 for first object. Returns -1 if Convert interface not used.

## GetDefaultFormat()

OBFormat * GetDefaultFormat | ( |  | ) |

inline static inherited

The default format is set in a single OBFormat class (generally it is OBMol).

## Write()

bool Write | ( | OBBase * | pOb,
|  | std::ostream * | pout = nullptr )

inherited

Outputs an object of a class derived from OBBase.

Part of "API" interface. The output stream can be specified and the change is retained in the OBConversion instance

Writes the object pOb but does not delete it afterwards. The output stream is lastingly changed if pos is not NULL Returns true if successful.

Examples
  obconformersearch_default.cpp.

Referenced by WriteFile(), and WriteString().

## WriteString()

std::string WriteString | ( | OBBase * | pOb,
|  | bool | trimWhitespace = false )

inherited

Outputs an object of a class derived from OBBase as a string.

Part of "API" interface. The output stream is temporarily changed to the string and then restored This method is primarily intended for scripting languages without "stream" classes The optional "trimWhitespace" parameter allows trailing whitespace to be removed (e.g., in a SMILES string or InChI, etc.)

Writes the object pOb but does not delete it afterwards. The output stream not changed (since we cannot write to this string later) Returns true if successful.

Referenced by OBBuilder::Build(), and UniqueTautomerFunctor::operator()().

## WriteFile()

bool WriteFile | ( | OBBase * | pOb,
|  | std::string | filePath )

inherited

Outputs an object of a class derived from OBBase as a file (with the supplied path).

Part of "API" interface. The output stream is changed to the supplied file and the change is retained in the OBConversion instance. This method is primarily intended for scripting languages without "stream" classes

Writes the object pOb but does not delete it afterwards. The output stream is lastingly changed to point to the file Returns true if successful.

## CloseOutFile()

void CloseOutFile | ( |  | ) |

inherited

Manually closes and deletes the output stream The file is closed anyway when in the OBConversion destructor or when WriteFile is called again.

Since
  version 2.1

## Read()

bool Read | ( | OBBase * | pOb,
|  | std::istream * | pin = nullptr )

inherited

Reads an object of a class derived from OBBase into pOb.

Part of "API" interface. The input stream can be specified and the change is retained in the OBConversion instance

Returns
  false and pOb=NULL on error

Examples
  obconformersearch_default.cpp, and obforcefield_energy.cpp.

Referenced by ReadFile(), OBMoleculeFormat::ReadNameIndex(), and ReadString().

## ReadString()

bool ReadString | ( | OBBase * | pOb,
|  | std::string | input )

inherited

Reads an object of a class derived from OBBase into pOb from the supplied string.

Part of "API" interface. The input stream can be specified and the change is retained in the OBConversion instance

Returns
  NULL on error Part of "API" interface.
  false and pOb=NULL on error This method is primarily intended for scripting languages without "stream" classes Any existing input stream will be replaced by stringstream.

Examples
  obconversion_readstring.cpp.

Referenced by OpenBabel::CompileSmilesQuery().

## ReadFile()

bool ReadFile | ( | OBBase * | pOb,
|  | std::string | filePath )

inherited

Reads an object of a class derived from OBBase into pOb from the file specified.

Part of "API" interface. The output stream is changed to the supplied file and the change is retained in the OBConversion instance. For multi-molecule files, the remaining molecules can be read by repeatedly calling the Read() method.

Returns
  false and pOb=NULL on error This method is primarily intended for scripting languages without "stream" classes

## OpenInAndOutFiles()

bool OpenInAndOutFiles | ( | std::string | infilepath,
|  | std::string | outfilepath )

inherited

Part of the "Convert" interface. Open the files and update the streams in the OBConversion object. This method is primarily intended for scripting languages without "stream" classes and will usually followed by a call to Convert(). Will set format from file extension if format has not already been set. Files will be opened even if format cannot be determined, but not if file path is empty.

Returns
  false if unsuccessful.

Referenced by OBConversion().

## ReportNumberConverted()

void ReportNumberConverted | ( | int | count,
|  | OBFormat * | pFormat = nullptr )

inherited

Sends a message like "2 molecules converted" to clog The type of object is taken from the TargetClassDescription of the specified class (or the output format if not specified)and is appropriately singular or plural.

## NumInputObjects()

int NumInputObjects | ( |  | ) |

inherited

Returns
  the number of objects in the inputstream, or -1 if error or if SkipObjects for the input format is not implemented Adjusts for the value of -f and -l options (first and last objects).

## BatchFileName()

string BatchFileName | ( | std::string & | BaseName,
|  | std::string & | InFile )

static protected inherited

Replaces * in BaseName by InFile without extension and path.

Referenced by FullConvert().

## IncrementedFileName()

string IncrementedFileName | ( | std::string & | BaseName,
|  | const int | Count )

static protected inherited

Replaces * in BaseName by Count.

Referenced by FullConvert().

## CheckForUnintendedBatch()

bool CheckForUnintendedBatch | ( | const std::string & | infile,
|  | const std::string & | outfile )

static protected inherited

Checks for misunderstandings when using the -m option.

Referenced by FullConvert().

## ClearInStreams()

void ClearInStreams | ( |  | ) |

protected inherited

## SetStartAndEnd()

bool SetStartAndEnd | ( |  | ) |

protected inherited

Referenced by Convert(), and Read().

## OptionParamArray()

OBConversion::OPAMapType & OptionParamArray | ( | Option_type | typ | ) |

static protected inherited

Referenced by GetOptionParams(), and RegisterOptionParam().

## OpenAndSetFormat()

bool OpenAndSetFormat | ( | bool | SetFormat,
|  | std::ifstream * | is,
|  | std::stringstream * | ss = nullptr )

protected inherited

Referenced by FullConvert().

## Member Data Documentation

## _SkipNextRead

bool _SkipNextRead

## InFilename

std::string InFilename

protected inherited

Referenced by FullConvert(), GetInFilename(), GetTitle(), OpenAndSetFormat(), OpenInAndOutFiles(), operator=(), and ReadFile().

## OutFilename

std::string OutFilename

protected inherited

Referenced by FullConvert(), GetOutFilename(), and OpenInAndOutFiles().

## pInput

std::istream* pInput

protected inherited

Referenced by AddChemObject(), Convert(), GetInStream(), OBConversion(), OBConversion(), operator=(), OBConversion::StreamState::popInput(), OBConversion::StreamState::pushInput(), Read(), and SetInStream().

## ownedInStreams

std::vector<std::istream *> ownedInStreams

protected inherited

Referenced by OBConversion::StreamState::popInput(), OBConversion::StreamState::pushInput(), Read(), and SetInStream().

## pOutput

std::ostream* pOutput

protected inherited

Referenced by FullConvert(), GetOutStream(), OBConversion(), OBConversion(), operator=(), OBConversion::StreamState::popOutput(), OBConversion::StreamState::pushOutput(), SetOutStream(), and Write().

## ownedOutStreams

std::vector<std::ostream *> ownedOutStreams

protected inherited

Referenced by OBConversion::StreamState::popOutput(), OBConversion::StreamState::pushOutput(), and SetOutStream().

## pDefaultFormat

OBFormat* pDefaultFormat

static protected inherited

## pInFormat

OBFormat* pInFormat

protected inherited

Referenced by Convert(), Convert(), FullConvert(), GetInFormat(), OBConversion(), OBConversion(), OpenAndSetFormat(), OpenInAndOutFiles(), operator=(), Read(), ReadFile(), SetInFormat(), SetInFormat(), SetInStream(), and SetStartAndEnd().

## pOutFormat

OBFormat* pOutFormat

protected inherited

Referenced by AddChemObject(), Convert(), GetOutFormat(), OBConversion(), OBConversion(), OpenInAndOutFiles(), operator=(), ReportNumberConverted(), SetOutFormat(), SetOutFormat(), Write(), WriteFile(), and WriteString().

## OptionsArray

std::map<std::string,std::string> OptionsArray[3]

protected inherited

Referenced by AddOption(), CopyOptions(), GetOptions(), IsOption(), operator=(), RemoveOption(), and SetOptions().

## Index

int Index

protected inherited

Referenced by AddChemObject(), Convert(), GetChemObject(), GetOutputIndex(), OBConversion(), OBConversion(), operator=(), SetOutputIndex(), Write(), WriteFile(), and WriteString().

## StartNumber

unsigned int StartNumber

protected inherited

Referenced by AddChemObject(), Convert(), OBConversion(), OBConversion(), operator=(), and SetStartAndEnd().

## EndNumber

unsigned int EndNumber

protected inherited

Referenced by AddChemObject(), Convert(), OBConversion(), OBConversion(), operator=(), Read(), and SetStartAndEnd().

## Count

int Count

protected inherited

Referenced by AddChemObject(), Convert(), FullConvert(), GetCount(), IncrementedFileName(), OBConversion(), OBConversion(), operator=(), Read(), and SetStartAndEnd().

## m_IsFirstInput

bool m_IsFirstInput

protected inherited

Referenced by IsFirstInput(), OBConversion(), OBConversion(), operator=(), and SetFirstInput().

## m_IsLast

bool m_IsLast

protected inherited

Referenced by Convert(), IsLast(), OBConversion(), OBConversion(), operator=(), SetOneObjectOnly(), and WriteString().

## MoreFilesToCome

bool MoreFilesToCome

protected inherited

Referenced by Convert(), IsLastFile(), OBConversion(), OBConversion(), operator=(), and SetMoreFilesToCome().

## OneObjectOnly

bool OneObjectOnly

protected inherited

Referenced by Convert(), OBConversion(), OBConversion(), operator=(), SetOneObjectOnly(), and WriteString().

## ReadyToInput

bool ReadyToInput

protected inherited

Referenced by AddChemObject(), Convert(), and operator=().

## SkippedMolecules

bool SkippedMolecules

protected inherited

Referenced by OBConversion(), OBConversion(), operator=(), and Read().

## inFormatGzip

bool inFormatGzip

protected inherited

skip molecules using -f and -l

Referenced by Convert(), FullConvert(), GetInGzipped(), OBConversion(), OBConversion(), OpenAndSetFormat(), OpenInAndOutFiles(), operator=(), Read(), ReadFile(), SetInFormat(), SetInFormat(), and SetInStream().

## outFormatGzip

bool outFormatGzip

protected inherited

Referenced by GetOutGzipped(), OBConversion(), OBConversion(), OpenInAndOutFiles(), operator=(), SetOutFormat(), SetOutFormat(), SetOutStream(), and WriteFile().

## pOb1

OBBase* pOb1

protected inherited

Referenced by AddChemObject(), Convert(), GetChemObject(), OBConversion(), OBConversion(), and operator=().

## wInpos

std::streampos wInpos

protected inherited

position in the input stream of the object being written

Referenced by AddChemObject(), GetInPos(), OBConversion(), OBConversion(), and operator=().

## rInpos

std::streampos rInpos

protected inherited

position in the input stream of the object being read

Referenced by AddChemObject(), Convert(), and operator=().

## wInlen

size_t wInlen

protected inherited

length in the input stream of the object being written

Referenced by AddChemObject(), Convert(), GetInLen(), OBConversion(), OBConversion(), and operator=().

## rInlen

size_t rInlen

protected inherited

length in the input stream of the object being read

Referenced by AddChemObject(), and operator=().

## pAuxConv

OBConversion* pAuxConv

protected inherited

Way to extend OBConversion.

Referenced by GetAuxConv(), OBConversion(), OBConversion(), operator=(), SetAuxConv(), and ~OBConversion().

## SupportedInputFormat

std::vector<std::string> SupportedInputFormat

protected inherited

list of supported input format

## SupportedOutputFormat

std::vector<std::string> SupportedOutputFormat

protected inherited

list of supported output format

The documentation for this class was generated from the following file:

- xml.h